local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Aladdin1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Aladdin1.fbx/Prefab/CorePart", "PREFAB_ALADDIN_CORE")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart1", "PREFAB_ALADDIN_REMOVER1")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart2", "PREFAB_ALADDIN_REMOVER2")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart3", "PREFAB_ALADDIN_REMOVER3")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/RemoverPart4", "PREFAB_ALADDIN_REMOVER4")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/BerryBasketPart", "PREFAB_ALADDIN_BASKET_BERRIES")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/BreadBasketPart", "PREFAB_ALADDIN_BASKET_BREAD")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/FishBasketPart", "PREFAB_ALADDIN_BASKET_FISH")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/ClothesCratePart", "PREFAB_ALADDIN_CRATES_CLOTHES")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/HoneyPotPart", "PREFAB_ALADDIN_POT_HONEY")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/GoldChestPart", "PREFAB_ALADDIN_CHEST_GOLD")
mod:registerAssetId("models/Aladdin1.fbx/Prefab/PumpkinPart", "PREFAB_ALADDIN_PUMPKIN")



-- -- Comp Building Part -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/Aladdin1.fbx/Prefab/BerryBasketPart", { DataType = "COMP_BUILDING_PART" })



-- -- Material -------------------------------------------------------------------------------------
-- mod:registerAssetId("models/Aladdin1.fbx/Materials/Material.Semitransparent", "MATERIAL_ALADDIN_SEMITRANSPARENT")
-- mod:override({
-- 	Id = "MATERIAL_ALADDIN_SEMITRANSPARENT",
-- 	HasTransparency = true,
--     IsLighted = true,
--     HasShadow = true,
--     TransparencyOrder = 1
-- })



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Health1.fbx/Prefab/HospitalPart", { "PLATFORM" })



-- Grounding  -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/Health1.fbx/Prefab/DoorPart", { DataType = "COMP_GROUNDED" })



-- Building: Aladdin -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_ALADDIN",
	Name = "BUILDING_ALADDIN_NAME",
	Description = "BUILDING_ALADDIN_DESC",
    BuildingType = "DECORATION",
    AssetCoreBuildingPart = "BUILDING_PART_ALADDIN_CORE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_PART_SET_ALADDIN_2",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_BERRY",
                "BUILDING_PART_ALADDIN_STONE",
                "BUILDING_PART_ALADDIN_FISH",
                -- "BUILDING_PART_ALADDIN_MINERAL1",
                -- "BUILDING_PART_ALADDIN_MINERAL2",
                -- "BUILDING_PART_ALADDIN_MINERAL3",
                -- trees cause crashes if placed more than one
                -- "BUILDING_PART_ALADDIN_OAK",
                -- "BUILDING_PART_ALADDIN_SYCAMORE",
                -- "BUILDING_PART_ALADDIN_POPLAR",
                -- "BUILDING_PART_ALADDIN_PINE",
            }
		},
		{
			Name = "BUILDING_PART_SET_ALADDIN_3",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_INFINITE_GOLD",
                "BUILDING_PART_ALADDIN_INFINITE_BERRY",
                "BUILDING_PART_ALADDIN_INFINITE_BREAD",
                "BUILDING_PART_ALADDIN_INFINITE_FISH",
                "BUILDING_PART_ALADDIN_INFINITE_CLOTHES",
                "BUILDING_PART_ALADDIN_INFINITE_HONEY",
            }
		},
		-- {
		-- 	Name = "BUILDING_PART_SET_ALADDIN_4",
		-- 	BuildingPartList = { 
        --         "BUILDING_PART_ALADDIN_IMMIGRATION",
        --     }
		-- },
		{
			Name = "BUILDING_PART_SET_ALADDIN_1",
			BuildingPartList = { 
                "BUILDING_PART_ALADDIN_REMOVER2",
                "BUILDING_PART_ALADDIN_REMOVER3",
                "BUILDING_PART_ALADDIN_REMOVER4",
                "BUILDING_PART_ALADDIN_REMOVER1",
            }
		},
	},	
	IsEditable = true
})



-- Building Part: Core -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_CORE",
	Name = "BUILDING_PART_ALADDIN_CORE_NAME",
    Description = "BUILDING_ALADDIN_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CORE"
    }, 
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0, 0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
		}
	}
})



-- Building Part: Remover 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER1",
	Name = "BUILDING_PART_ALADDIN_REMOVER1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER1"
    },
	DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "SUBSTRACT",
			Radius = 10,
			Value = 0
		}
	}
})



-- Custom Component: Remover 1 (berries and stone) -------------------------------------------------------------------------------------
local COMP_ALADDIN_REMOVER1 = {
	TypeName = "COMP_ALADDIN_REMOVER1",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_REMOVER1:update()

    -- Find and remove stone or berry bushes within radius
    objlist = {}
    local pos1 = self:getOwner():getGlobalPosition()

    self:getLevel():getComponentManager("COMP_RESOURCE_CONTAINER"):getAllEnabledComponent():forEach(function(compContainer)
        local compName = compContainer.ResourceData.ResourceName
        if (compName) then
            -- mod:log(tostring(compName))
            if (tostring(compName) == "BERRIES" or tostring(compName) == "STONES") then
                local compPart = compContainer:getOwner():getComponent("COMP_BUILDING_PART")
                if (not compPart) then -- do not delete if the resource container is part of a building
                    local pos2 = compContainer:getOwner():getGlobalPosition()
                    local distance = math.sqrt( (pos1.x - pos2.x)^2 + (pos1.z - pos2.z)^2 )
                    if (distance <= 10) then
                        -- insert the object ID into the table
                        table.insert(objlist, 1, compContainer:getOwner():getParent():getId())
                    end
                end
            end
        end
    end)

    -- Destroy the objects
    if (#objlist > 0) then
        local iObj = #objlist
        for i=1, iObj, 1 do
            local objtarget = self:getLevel():find(tostring(objlist[i]))
            if (objtarget) then 
                objtarget:destroy() 
            end
        end
    end

    -- Destroy the building part that was used to remove the resources
	self:getOwner():destroyAllChild()
	self:getOwner():destroy()

end

mod:registerClass(COMP_ALADDIN_REMOVER1)
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER1", { DataType = "COMP_ALADDIN_REMOVER1" } )



-- Building Part: Remover 2 (trees, circle) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER2",
	Name = "BUILDING_PART_ALADDIN_REMOVER2_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER2"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 5, {0, 0}, 24 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Building Part: Remover 3 (trees, square) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER3",
	Name = "BUILDING_PART_ALADDIN_REMOVER3_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER3"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5, 5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Building Part: Remover 4 (trees, rectangle) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_REMOVER4",
	Name = "BUILDING_PART_ALADDIN_REMOVER4_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_REMOVER4"
    },
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.5, 7.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
		}
	}
})



-- Custom Component: Remover 2 (trees) -------------------------------------------------------------------------------------
local COMP_ALADDIN_REMOVER2 = {
	TypeName = "COMP_ALADDIN_REMOVER2",
	ParentType = "COMPONENT"
}

function COMP_ALADDIN_REMOVER2:update()

    -- Destroy the building part that was used to remove the trees
	self:getOwner():destroyAllChild()
	self:getOwner():destroy()

end

mod:registerClass(COMP_ALADDIN_REMOVER2)
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER2", { DataType = "COMP_ALADDIN_REMOVER2" } )
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER3", { DataType = "COMP_ALADDIN_REMOVER2" } )
mod:registerPrefabComponent("PREFAB_ALADDIN_REMOVER4", { DataType = "COMP_ALADDIN_REMOVER2" } )



-- Building Part: Berry -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_BERRY",
	Name = "BUILDING_PART_ALADDIN_BERRY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_BERRIES"
    }
})



-- Building Part: Stone -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_STONE",
	Name = "BUILDING_PART_ALADDIN_STONE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_ROCK"
    }
})



-- Building Part: Fish -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_FISH",
	Name = "BUILDING_PART_ALADDIN_FISH_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_RESOURCE_FISH"
    }
})



-- -- Building Part: Mineral 1 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL1",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL1_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_1"
--     }
-- })

-- -- Custom Component: Mineral 1 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL1 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL1",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL1:onEnabled()

--     mod:log(tostring(self))
--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_1", pos1, orient1)

--         -- Remove the building part that initiated this change
--         self:getOwner():destroyAllChild()
--         self:getOwner():destroy()

--     -- else

--     --     local comp = self:getOwner():getComponent("COMP_ALADDIN_MINERAL1")
--     --     if (comp) then
--     --         self:getOwner():removeComponent(comp)
--     --     end

--     end

-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL1)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_1", { DataType = "COMP_ALADDIN_MINERAL1" } )



-- -- Building Part: Mineral 2 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL2",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL2_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_2"
--     }
-- })

-- -- Custom Component: Mineral 2 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL2 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL2",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL2:update()

--     -- local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     -- if (not compPart) then -- this is a native mineral node, destroy this component

--     --     self:getOwner():getComponent("COMP_ALADDIN_MINERAL3"):destroy()

--     -- else

--     --     -- Record position of the placed building part
--     --     local pos1 = self:getOwner():getGlobalPosition()
--     --     local orient1 = self:getOwner():getGlobalOrientation()

--     --     -- Add an identical prefab to the same spot
--     --     prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_2", pos1, orient1)

--     --     -- Destroy the building part that was used to create the node
--     --     self:getOwner():destroyAllChild()
--     --     self:getOwner():destroy()

--     -- end

--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_2", pos1, orient1)

--     end

--     -- Destroy the building part that was used to create the node
--     self:destroy()

-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL2)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_2", { DataType = "COMP_ALADDIN_MINERAL2" } )



-- -- Building Part: Mineral 3 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_MINERAL3",
-- 	Name = "BUILDING_PART_ALADDIN_MINERAL3_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_MINERAL_SOURCE_3"
--     }
-- })

-- -- Custom Component: Mineral 3 -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_MINERAL3 = {
-- 	TypeName = "COMP_ALADDIN_MINERAL3",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_MINERAL3:update()

--     local compPart = self:getOwner():getComponent("COMP_BUILDING_PART")
--     if (compPart) then

--         -- Record position of the placed building part
--         local pos1 = self:getOwner():getGlobalPosition()
--         local orient1 = self:getOwner():getGlobalOrientation()

--         -- Add an identical prefab to the same spot
--         prefabNew = self:getLevel():createObject("PREFAB_MINERAL_SOURCE_3", pos1, orient1)
--         self:destroy()

--     else
--         self:destroy()
--     end


-- end

-- mod:registerClass(COMP_ALADDIN_MINERAL3)
-- mod:registerPrefabComponent("PREFAB_MINERAL_SOURCE_3", { DataType = "COMP_ALADDIN_MINERAL3" } )



-- -- Building Part: Oak -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_OAK",
-- 	Name = "BUILDING_PART_ALADDIN_OAK_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_OAK"
--     }
-- })



-- -- Building Part: Sycamore -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_SYCAMORE",
-- 	Name = "BUILDING_PART_ALADDIN_SYCAMORE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_SYCAMORE"
--     }
-- })



-- -- Building Part: Poplar -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_POPLAR",
-- 	Name = "BUILDING_PART_ALADDIN_POPLAR_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_POPLAR"
--     }
-- })



-- -- Building Part: Pine -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_PINE",
-- 	Name = "BUILDING_PART_ALADDIN_PINE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_TREE_PINE"
--     }
-- })



-- Building Part: Infinite Gold -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_GOLD",
	Name = "BUILDING_PART_ALADDIN_INFINITE_GOLD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CHEST_GOLD"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.5, 0.7}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_GOLD_NAME",
    ResourceGenerated = "GOLD_COINS",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Berries -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_BERRY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_BERRY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_BERRIES"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.3, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_BERRY_NAME",
    ResourceGenerated = "BERRIES",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Bread -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_BREAD",
	Name = "BUILDING_PART_ALADDIN_INFINITE_BREAD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_BREAD"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_BREAD_NAME",
    ResourceGenerated = "BREAD",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Fish -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_FISH",
	Name = "BUILDING_PART_ALADDIN_INFINITE_FISH_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_BASKET_FISH"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_FISH_NAME",
    ResourceGenerated = "FISH",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Clothes -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_CLOTHES",
	Name = "BUILDING_PART_ALADDIN_INFINITE_CLOTHES_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_CRATES_CLOTHES"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.6, 1.6}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_CLOTHES_NAME",
    ResourceGenerated = "CLOTHES",
    IsForConsumer = true,
    IsInfinite = true
})



-- Building Part: Infinite Honey -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ALADDIN_INFINITE_HONEY",
	Name = "BUILDING_PART_ALADDIN_INFINITE_HONEY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ALADDIN_POT_HONEY"
    },
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.4, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
})

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY",
    Name = "BUILDING_FUNCTION_ALADDIN_GENERATE_HONEY_NAME",
    ResourceGenerated = "HONEY",
    IsForConsumer = true,
    IsInfinite = true
})



-- -- Building Part: Immigration Pumpkin -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_ALADDIN_IMMIGRATION",
-- 	Name = "BUILDING_PART_ALADDIN_IMMIGRATION_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_ALADDIN_PUMPKIN"
--     }
-- })

-- -- Custom Component: Immigration -------------------------------------------------------------------------------------
-- local COMP_ALADDIN_IMMIGRATION = {
-- 	TypeName = "COMP_ALADDIN_IMMIGRATION",
-- 	ParentType = "COMPONENT"
-- }

-- function COMP_ALADDIN_IMMIGRATION:init()


-- end

-- mod:registerClass(COMP_ALADDIN_IMMIGRATION)
-- mod:registerPrefabComponent("PREFAB_ALADDIN_PUMPKIN", { DataType = "COMP_ALADDIN_IMMIGRATION" } )
